// u_80_generic_implementation
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_80_generic_implementation;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    display_memory_address_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure display_memory_address_Click(Sender: TObject);
    procedure bClick(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple
      , u_c_some_generic
      ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.display_memory_address_Click(Sender: TObject);

      procedure display_address(p_title: String; p_address: Integer);
        begin
         display(Format('%-25s $%8x', [p_title, p_address]));
        end; // display_address

      var l_c_integer: c_some_generic<Integer>;
          l_c_string: c_some_generic<string>;
          l_c_button: c_some_generic<tButton>;

      begin // display_memory_address_Click
        l_c_integer := c_some_generic<Integer>.Create;
        l_c_integer.set_T (10);
        l_c_integer.non_generic;

        l_c_string := c_some_generic<string>.Create;
        l_c_string.set_T ('hello');
        l_c_string.non_generic;

        l_c_button:= c_some_generic<tButton>.Create;
        l_c_button.set_T (Exit_);
        l_c_button.non_generic;

        display('');
        display('non generic addresses');
        display_address('l_c_string.non_generic',  pInteger(@c_some_generic<string>.non_generic)^);
        display_address('l_c_integer.non_generic', pInteger(@c_some_generic<Integer>.non_generic)^);
        display_address('l_c_button.non_generic',  pInteger(@c_some_generic<tButton>.non_generic)^);

        display('');
        display('generic_addresses');
        display_address('l_c_string.set_T',        pInteger(@c_some_generic<string>.set_T)^);
        display_address('l_c_integer.set_T',       pInteger(@c_some_generic<Integer>.set_T)^);
        display_address('l_c_button.set_T',        pInteger(@c_some_generic<tButton>.set_T)^);
      end; // display_memory_address_Click

    procedure TForm1.bClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

